diff --git a/tools/mkconfigvars.sh b/tools/mkconfigvars.sh
index 0115996590..feb188a32a 100755
--- a/tools/mkconfigvars.sh
+++ b/tools/mkconfigvars.sh
@@ -32,6 +32,45 @@
 # POSSIBILITY OF SUCH DAMAGE.
 #
 
+USAGE="USAGE: $0 [-d|h] [-v <major.minor>]"
+ADVICE="Try '$0 -h' for more information"
+
+unset VERSION
+
+while [ ! -z "$1" ]; do 
+    case $1 in
+    -v )
+        shift
+        VERSION=$1
+        ;;
+    -d )
+        set -x
+        ;;
+    -h )
+        echo "$0 is a tool for generation of configuration variable documentation"
+        echo ""
+        echo $USAGE
+        echo ""
+        echo "Where:"
+        echo "  -v <major.minor>"
+        echo "     The NuttX version number expressed as a major and minor number separated"
+        echo "     by a period"
+        echo "  -d"
+        echo "     Enable script debug"
+        echo "  -h"
+        echo "     show this help message and exit"
+        exit 0
+        ;;
+    * )
+        echo "Unrecognized option: ${1}"
+        echo $USAGE
+        echo $ADVICE
+        exit 1
+        ;;
+    esac
+    shift
+done
+
 # Find the directory we were executed from and were we expect to
 # see the directories to tar up
 
@@ -44,18 +83,12 @@ KCONFIG2MAKEDIR=tools
 HTMLFILE=Documentation/NuttXConfigVariables.html
 BKUPFILE=Documentation/NuttXConfigVariables.bkp
 
-# A version argument may be provided
-
-if [ ! -z "${1}" ]; then
-  VERSION=${1}
-fi
-
 if [ -x ./${MYNAME} ] ; then
    cd .. || { echo "ERROR: cd .. failed" ; exit 1 ; }
 fi
 
 if [ ! -x tools/${MYNAME} ] ; then
-   echo "ERROR:  This file must be executed from the top-level NuttX directory"
+   echo "ERROR:  This file must be executed from the top-level NuttX directory: $PWD"
    exit 1
 fi
 
diff --git a/tools/zipme.sh b/tools/zipme.sh
index 67a9b1e8f6..975e63c0d7 100755
--- a/tools/zipme.sh
+++ b/tools/zipme.sh
@@ -45,7 +45,9 @@ USAGE="USAGE: $0 [-d|h] [-b <build]> <major.minor>"
 ADVICE="Try '$0 -h' for more information"
 
 unset VERSION
+unset VERSIONOPT
 unset BUILD
+unset DEBUG
 
 while [ ! -z "$1" ]; do 
     case $1 in
@@ -55,6 +57,7 @@ while [ ! -z "$1" ]; do
         ;;
     -d )
         set -x
+        DEBUG=-d
         ;;
     -h )
         echo "$0 is a tool for generation of release versions of NuttX"
@@ -84,6 +87,7 @@ done
 # The last thing on the command line is the version number
 
 VERSION=$1
+VERSIONOPT="-v ${VERSION}"
 
 # Make sure we know what is going on
 
@@ -94,6 +98,18 @@ if [ -z ${VERSION} ] ; then
    exit 1;
 fi
 
+if [ -z "${BUILD}" ]; then
+    GITINFO=`git log 2>/dev/null | head -1`
+    if [ -z "${GITINFO}" ]; then
+        echo "GIT version information is not available. Use the -b option"
+        echo $USAGE
+        echo $ADVICE
+        exit 1;
+    fi
+    echo "GIT: ${GITINFO}"
+fi
+
+
 # Find the directory we were executed from and were we expect to
 # see the directories to tar up
 
@@ -170,7 +186,7 @@ if [ ! -x "${VERSIONSH}" ]; then
     exit 1
 fi
 
-${VERSIONSH} ${BUILD} -v ${VERSION} ${NUTTX}/.version || \
+${VERSIONSH} ${DEBUG} ${BUILD} ${VERSIONOPT} ${NUTTX}/.version || \
     { echo "${VERSIONSH} failed"; cat ${NUTTX}/.version; exit 1; }
 chmod 755 ${NUTTX}/.version || \
     { echo "'chmod 755 ${NUTTX}/.version' failed"; exit 1; }
@@ -185,7 +201,10 @@ if [ ! -x "${MKCONFIGVARS}" ]; then
     exit 1
 fi
 
-${MKCONFIGVARS} ${VERSION} || \
+cd ${NUTTX} || \
+   { echo "Failed to cd to ${NUTTX}" ; exit 1 ; }
+
+${MKCONFIGVARS} ${DEBUG} ${VERSIONOPT} || \
     { echo "${MKCONFIGVARS} failed"; exit 1; }
 chmod 644 ${CONFIGVARHTML} || \
     { echo "'chmod 644 ${CONFIGVARHTML}' failed"; exit 1; }